// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/future_reservations/v1/future_reservations.proto

#include "google/cloud/compute/future_reservations/v1/future_reservations_connection_idempotency_policy.h"
#include <memory>

namespace google {
namespace cloud {
namespace compute_future_reservations_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

FutureReservationsConnectionIdempotencyPolicy::
    ~FutureReservationsConnectionIdempotencyPolicy() = default;

std::unique_ptr<FutureReservationsConnectionIdempotencyPolicy>
FutureReservationsConnectionIdempotencyPolicy::clone() const {
  return std::make_unique<FutureReservationsConnectionIdempotencyPolicy>(*this);
}

Idempotency
FutureReservationsConnectionIdempotencyPolicy::AggregatedListFutureReservations(
    google::cloud::cpp::compute::future_reservations::v1::
        AggregatedListFutureReservationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency FutureReservationsConnectionIdempotencyPolicy::Cancel(
    google::cloud::cpp::compute::future_reservations::v1::
        CancelRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
FutureReservationsConnectionIdempotencyPolicy::DeleteFutureReservation(
    google::cloud::cpp::compute::future_reservations::v1::
        DeleteFutureReservationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency FutureReservationsConnectionIdempotencyPolicy::GetFutureReservation(
    google::cloud::cpp::compute::future_reservations::v1::
        GetFutureReservationRequest const&) {
  return Idempotency::kIdempotent;
}

Idempotency
FutureReservationsConnectionIdempotencyPolicy::InsertFutureReservation(
    google::cloud::cpp::compute::future_reservations::v1::
        InsertFutureReservationRequest const&) {
  return Idempotency::kNonIdempotent;
}

Idempotency
FutureReservationsConnectionIdempotencyPolicy::ListFutureReservations(
    google::cloud::cpp::compute::future_reservations::v1::
        ListFutureReservationsRequest) {  // NOLINT
  return Idempotency::kIdempotent;
}

Idempotency
FutureReservationsConnectionIdempotencyPolicy::UpdateFutureReservation(
    google::cloud::cpp::compute::future_reservations::v1::
        UpdateFutureReservationRequest const&) {
  return Idempotency::kNonIdempotent;
}

std::unique_ptr<FutureReservationsConnectionIdempotencyPolicy>
MakeDefaultFutureReservationsConnectionIdempotencyPolicy() {
  return std::make_unique<FutureReservationsConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_future_reservations_v1
}  // namespace cloud
}  // namespace google
